

#include <curses.h>
#include "interface.h"

int position[NUMCONTROLS];

int init_display (int mixervalue[NUMCONTROLS], char* labels[])
{

int i,j;
char focus[20];

/* initial setup */
   initscr();
   nl();
   curs_set(0);
   timeout(0);
   cbreak();
   noecho();
   clear();
   start_color();
   use_default_colors();


       init_pair(1, FG_COLOR, BG_COLOR);
       init_pair(2, PGFG_COLOR, PGBG_COLOR);
       init_pair(3, BG_COLOR, BG_COLOR);


       attrset(COLOR_PAIR(3));
       for(i=0;i<80;i++)
       {
	       for(j=0;j<25;j++)
	       {
		       mvaddstr(j, i, " ");
	       }
       }


       
       
       
       attrset(COLOR_PAIR(1));
       mvhline (0, 1, ACS_HLINE, 78);
       mvvline (1, 0, ACS_VLINE, 23);
       mvvline (1, 79, ACS_VLINE, 23);
       mvhline (0, 0, ACS_ULCORNER, 1);  
       mvhline (0, 79, ACS_URCORNER, 1);
       mvhline (24, 0, ACS_LLCORNER, 1);
       mvhline (24, 79, ACS_LRCORNER, 1);
       mvhline (24, 1, ACS_HLINE, 78);
  
       mvhline(0, 30, ACS_VLINE, 1);
       mvhline(0, 49, ACS_VLINE, 1);
       
       mvaddstr (0, 31, " t  a  r  a  n  g ");



   /* draw interface */
   for ( i=0; i<NUMCONTROLS; i++ ) 
   {
  	   mvaddstr (YINI+i*GAP, STARTX-2, "[");
	   mvaddstr (YINI+i*GAP, ENDX+1, "]");
	   position[i] = mixervalue[i]/2;
	   if (i==0)
 	   sprintf(focus,"-->%s<--",labels[i]);
          else
       	   sprintf(focus,"   %s   ",labels[i]);
           
	  mvaddstr(YINI+i*GAP, LABELSTARTX, focus);
   
           if (mixervalue[i] != -1)
	   {
	        display_percent (i) ; 
	   }
	   else
	   {
		position[i]=-1; 
		mvaddstr(YINI+i*GAP,STARTX,"--NA--");
	   }
           attrset(COLOR_PAIR(2));
           for ( j=STARTX; j<STARTX+position[i]; j++ )
  	   {
		   mvaddstr (YINI+i*GAP, j, PROGRESSCHAR);
	   }
	   attrset(COLOR_PAIR(1));
   }

       
       mvaddstr (YINI+i*GAP,STARTX,"0");
       mvaddstr (YINI+i*GAP,STARTX+11,"25"); 
       mvaddstr (YINI+i*GAP,STARTX+24,"50"); 
       mvaddstr (YINI+i*GAP,STARTX+36,"75");
       mvaddstr (YINI+i*GAP,STARTX+48,"100");

  return 0;
}



int update (int index, int mod)
{

       init_pair(1, FG_COLOR, BG_COLOR);
       init_pair(2, PGFG_COLOR, PGBG_COLOR);
       init_pair(3, BG_COLOR, BG_COLOR);

if (position[index] != -1)
 {
	
	if (mod==1) 
	{
		attrset(COLOR_PAIR(2));
	        mvaddstr (YINI+index*GAP, STARTX+position[index], PROGRESSCHAR);
       	}
	else
	{
		attrset(COLOR_PAIR(3));
		mvaddstr (YINI+index*GAP, STARTX+position[index]-1, " ");
	}
	
	position[index] += mod;

	display_percent(index);
 }
return 0;

}


	
int update_focus (int index, char* labels[], int mod)
{
	
       int old_index;
       char focus[20];
       init_pair(1, FG_COLOR, BG_COLOR);
       init_pair(2, PGFG_COLOR, PGBG_COLOR);
       init_pair(3, BG_COLOR, BG_COLOR);

        
	
        if (mod==1) 
	{       if(index==0)old_index=NUMCONTROLS-1;
		else
		old_index=index-1;
	}
	else 
	{
		if(index==NUMCONTROLS-1)old_index=0;
		else
		old_index=index+1;
	}
        
        sprintf(focus,"   %s   ",labels[old_index]);
        mvaddstr (YINI+old_index*GAP, LABELSTARTX, focus);
        sprintf(focus,"-->%s<--",labels[index]);
        mvaddstr(YINI+index*GAP, LABELSTARTX, focus);

return 0;
}
	


int display_percent(int index)
{
	

        int percent = (float)(position[index])/50.0 * 100 ;
        char per[3];

       init_pair(1, FG_COLOR, BG_COLOR);
       init_pair(2, PGFG_COLOR, PGBG_COLOR);
       init_pair(3, BG_COLOR, BG_COLOR);

        attrset(COLOR_PAIR(1));
	sprintf (per,"%d%% ",percent);


	mvaddstr(YINI+index*GAP, PERCENTSTARTX, per);

return 0;
}
	




int exit_curses (void)
{
	getch ();
	curs_set (1);
        endwin ();

 return 0;	
}
   
  






   



	

	

	
 
	
    
 
 
	

