
/* 
 *
 *         >>TARANG - the Audio Mixer<<
 *  
 *        tarang.c  Written By Sreejith S
 *        
 *        email :-  sreejithsin@hotpop.com
 *        
 *  
 */

#include <sys/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>
#include "interface.h"


int exit_proc (int handle)
{
	exit_curses ();
  	if ( handle != -1 )
	{
		close(handle);
	}
return 0;
}
		

int doioctl (int handle, int mixervalue, int index, int mod)
{
        mixervalue += 2*mod ;
	mixervalue |= mixervalue<<8 ;	
	ioctl (handle, MIXER_WRITE(index), &mixervalue);

return 0;
}


int main (int argc, char** argv)
{

int handle=(-1), ok=1;
int i,check,index=0;
int mixervalue[NUMCONTROLS];
char c;
char* labels[] = SOUND_DEVICE_LABELS ;


if ( argc == 2)
{
	
	if ( strcmp(argv[1],"--help") == 0 )
	{
		printf ("Tarang is an audio mixer Program for Linux\n");
		printf ("Written by Sreejith S\n");
		printf ("email : sreejithsin@hotpop.com \n");

	}
	else
	{
		printf (" try tarang --help to know more \n");
	}

return (0);
}



/* opening handle to /dev/mixer  */
if ( (handle=open("/dev/mixer", O_RDWR)) == (-1) )
{
	perror("/dev/mixer");
	return 0;
}


/* getting current mixer settings  */
for (i=0; i<NUMCONTROLS; i++)
{
mixervalue[i]=0;
if(ioctl (handle, MIXER_READ(i), &mixervalue[i]) == -1 )
{
	mixervalue[i]=-1;
	//perror("ioctl_mixer_read");
	
}
mixervalue[i] >>= 8;

}


/* intialising display */
init_display (mixervalue,labels);



while (ok)
{
 

 switch (c=getch())  
 {
          case 'q':
	  case 'Q':
                   ok=0;		  

	  case 27:
		  c=getch();
		  c=getch();

                  switch (c)
		  {
			  case 67:
 				  if (mixervalue[index]/2 < 50)
				  {					        
					if (mixervalue[index] != -1) {
					  doioctl(handle, mixervalue[index], index, 1);
					  update (index, 1);
					  mixervalue[index] += 2;
					}
				  }
				  break;

			  case 68:
		                  if (mixervalue[index]/2 > 0)
				  {
					if (mixervalue[index] != -1) {
					  doioctl(handle, mixervalue[index], index ,-1) ;
					  update (index, -1);
					  mixervalue[index] -= 2;
					}
				  }
				  break;
			  case 65:
				  if (index!=0) index--;
				  else index=NUMCONTROLS-1;
				  update_focus(index,labels,-1);
				  break;

			  case 66:
				  if (index != NUMCONTROLS-1) index++;
				  else index=0;
				  update_focus(index,labels,1);
				  break;
				  
			  default:
				  continue;
				  break;

		  }
		  
	  default:
		  continue;
 }

}


clear ();
exit_curses ();
exit_proc(handle);

}


